%*** main function for ex. 2
clear all;clc
%*** Test the function myLuRows, myLuCols, myLuRowsVec and myLuColsVec
A = rand(10);  % Create random 10-by-10 matrix

  % Calculate LU-decomposition w. myLuCols
  % Check if the result is correct 
  
  % Calculate LU-decomposition w. myLuRows
  % Check if the result is correct 
  
  % Calculate LU-decomposition w. myLuColsVec
  % Check if the result is correct 
  
  % Calculate LU-decomposition w. myLuRowsVec
  % Check if the result is correct 

%***Solve equation systems with *********
fprintf('\nLR-Zerlegung mit und ohne Pivotsuche\n');

%***********************************
fprintf('\nGleichungssystem des Aufgabenteils (i):\n');
A1 = [0, 1; 1, 1]
b1 = [1; 1]

fprintf('\n Loesung durch LR-Zerlegung:\n');
[L1,R1] = MyLu(A1);
x = solve_LR(L1,R1,b1)

fprintf('\n Loesung durch LR-Zerlegung mit Pivotsuche:\n');
[L1,R1,p1] = MyLuCols(A1);
x = solve_LRPiv(L1,R1,p1,b1)

%***********************************
fprintf('\nGleichungssystem des Aufgabenteisl (ii):\n');
A2 = [11,44, 1; 0.1, 0.4, 3; 0, 1, -1]
b2 = [1; 1; 1]

fprintf('\n Loesung durch LR-Zerlegung:\n');
[L2,R2] = MyLu(A2);
x = solve_LR(L2,R2,b2)

fprintf('\n Loesung durch LR-Zerlegung mit Pivotsuche:\n');
[L2,R2,p2] = MyLuCols(A2);
x = solve_LRPiv(L2,R2,p2,b2)

%***********************************
fprintf('\nGleichungssystem des Aufgabenteisl (iii):\n');

A3 = [0.001,1, 1; -1, 0.004,0.004; -1000, 0.004, 0.000004]
b3 = [1; 1; 1]

fprintf('\n Loesung durch LR-Zerlegung:\n');
[L3,R3] = MyLu(A3);
x = solve_LR(L3,R3,b3)

fprintf('\n Loesung durch LR-Zerlegung mit Pivotsuche:\n');
[L3,R3,p3] = MyLuCols(A3);
x = solve_LRPiv(L3,R3,p3,b3)  
  
%************************************  
%*** Compare times
N = [2.^(3:8),400,600,800,1000];

for k = 1:numel(N)
  n = N(k)
        % Create random n-by-n matrix A
  tic
        % Calculate LU-Decomposition with myLuCols
  timeLuC(k) = toc;
  tic
        % Calculate LU-Decomposition with myLuColsVec
  timeLuCV(k) = toc;  
  
  tic
        % Calculate LU-Decomposition with myLuRows
  timeLuR(k) = toc;
  tic
        % Calculate LU-Decomposition with myLuRowsVec  
  timeLuRV(k) = toc;
 
end

%*** plot the times
figure(1)
loglog(N,timeLuC  ,'ro-')
hold on
loglog(N,timeLuCV ,'ko--')
loglog(N,timeLuR  ,'g*-')
loglog(N,timeLuRV ,'b*--')
hold off
legend('myLuCols','myLuColsVec',...
       'myLuRows','myLuRowsVec','Location','NorthWest')